# EVM Contracts (V2)

{% hint style="info" %}
The EVM contracts are now deprecated.
{% endhint %}

All smart contracts on Ethereum are **immutable**. The `owner` role in the contract can *only* withdraw protocol fees, and is set to the L1 StarknetOwnerProxy ([Etherscan](https://etherscan.io/address/0x1e0ef4162e42c9bf820c307218c4e41ccca6e9cc)) contract, representing the governor on Starknet.

There are two kinds of contracts in Ekubo Protocol, stateful and stateless. Stateless contracts may be redeployed at any time for the use in our backend and interface. Stateful contracts are *never redeployed*, i.e. their addresses will never change.

The addresses of all Ethereum contracts are the same on Sepolia and Mainnet. The contracts are not deployed to any other EVM chain.

<table><thead><tr><th width="200.234375">Contract</th><th>Address</th></tr></thead><tbody><tr><td>Core</td><td><code>0xe0e0e08A6A4b9Dc7bD67BCB7aadE5cF48157d444</code><br><a href="https://etherscan.io/address/0xe0e0e08A6A4b9Dc7bD67BCB7aadE5cF48157d444#readContract">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0xe0e0e08A6A4b9Dc7bD67BCB7aadE5cF48157d444#readContract">Sepolia</a></td></tr><tr><td>Positions</td><td><code>0xA37cc341634AFD9E0919D334606E676dbAb63E17</code><br><a href="https://etherscan.io/address/0xA37cc341634AFD9E0919D334606E676dbAb63E17#readContract">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0xA37cc341634AFD9E0919D334606E676dbAb63E17#readContract">Sepolia</a></td></tr><tr><td>Oracle</td><td><code>0x51d02A5948496a67827242EaBc5725531342527C</code><br><a href="https://etherscan.io/address/0x514d5DE68852628Af2F1236F780866989660aDA6#readContract">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0x514d5DE68852628Af2F1236F780866989660aDA6#readContract">Sepolia</a></td></tr><tr><td>TWAMM</td><td><code>0xd4279c050da1f5c5b2830558c7a08e57e12b54ec</code><br><a href="https://etherscan.io/address/0xD4279c050DA1F5c5B2830558C7A08E57e12b54eC">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0xd4279c050da1f5c5b2830558c7a08e57e12b54ec">Sepolia</a></td></tr><tr><td>Orders</td><td><code>0xae1430e3e089794beacba260657fcd0f0967c18a</code><br><a href="https://etherscan.io/address/0xae1430e3e089794beacba260657fcd0f0967c18a">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0xae1430e3e089794beacba260657fcd0f0967c18a">Sepolia</a></td></tr><tr><td>Router (Stateless)</td><td><code>0x9995855C00494d039aB6792f18e368e530DFf931</code><br><a href="https://etherscan.io/address/0x9995855C00494d039aB6792f18e368e530DFf931#readContract">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0x9995855C00494d039aB6792f18e368e530DFf931#readContract">Sepolia</a></td></tr><tr><td>MEVResistRouter (Stateless)</td><td><code>0x0c95eA31e4501B3b879Cae2232087E478D44aEAB</code><br><a href="https://etherscan.io/address/0x0c95eA31e4501B3b879Cae2232087E478D44aEAB#code">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0x0c95eA31e4501B3b879Cae2232087E478D44aEAB#code">Sepolia</a></td></tr><tr><td>MEVResist</td><td><code>0x553a2EFc570c9e104942cEC6aC1c18118e54C091</code><br><a href="https://etherscan.io/address/0x553a2efc570c9e104942cec6ac1c18118e54c091#internaltx">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0x553a2efc570c9e104942cec6ac1c18118e54c091#internaltx">Sepolia</a></td></tr><tr><td>PriceFetcher (Stateless)</td><td><code>0x5a9093673cdc9f7cae8b0d177797040b758205be</code></td></tr><tr><td>CoreDataFetcher (Stateless)</td><td><code>0x208bb00c6b142351e4a431f6dd323691ebb7c285</code><br></td></tr><tr><td>QuoteDataFetcher (Stateless)</td><td><code>0x91cB8a896cAF5e60b1F7C4818730543f849B408c</code></td></tr><tr><td>TokenWrapperFactory (Stateless)</td><td><code>0x2b8d80d891C1E20aca70fF8a85714aa1900Ab120</code><br><a href="https://etherscan.io/address/0x2b8d80d891c1e20aca70ff8a85714aa1900ab120">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0x2b8d80d891c1e20aca70ff8a85714aa1900ab120">Sepolia</a></td></tr><tr><td>TokenWrapperPeriphery (Stateless)</td><td><code>0x2992e49d73Cc97FbC69c5498F332984C9a89f5d6</code><br><a href="https://etherscan.io/address/0x2992e49d73cc97fbc69c5498f332984c9a89f5d6">Mainnet</a>, <a href="https://sepolia.etherscan.io/address/0x2992e49d73cc97fbc69c5498f332984c9a89f5d6">Sepolia</a></td></tr><tr><td>RevenueBuybacks</td><td>TBD</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ekubo.org/integration-guides/reference/evm-contracts-v2.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
